local cdframe = AceLibrary('AceAddon-2.0'):new('AceEvent-2.0', 'AceConsole-2.0', 'CandyBar-2.0')
local CandyBar = AceLibrary('CandyBar-2.0')
local name = "cdbar"

function cdframe:CreateFrame()
	self.frame = CreateFrame('Frame', name..'Frame', UIParent)
	self.frame:SetScript("OnEvent", OnEvent)
end
		  
-- Dispatch events
local function OnEvent(self, event, ...)
	local dispatch = self[event]
	if dispatch then
		dispatch(self,  ...)
	end
end

function cdframe:OnEnable()
	-- Register events
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterCandyBar(name, 60, 'CheatDeath CD', 'Interface\\Icons\\Ability_Rogue_CheatDeath', 'green')
	self:SetCandyBarHeight(name, 15)
	self:SetCandyBarWidth(name, 150)
	self:SetCandyBarIconPosition(name,'LEFT');
	self:SetCandyBarPoint(name, "CENTER", "UIParent", "CENTER", 0, 200)
	self:CreateFrame()
end

-- CombatLog function
function cdframe:COMBAT_LOG_EVENT_UNFILTERED(...)
-- Cheat Death check
	if((arg2=="SPELL_AURA_REMOVED") and (arg7==UnitName("player")) and (arg10=="Cheating Death")) then
		self:StartCandyBar(name, nil);
	end
-- Poison check
	if((arg2=="ENCHANT_REMOVED") and (arg7==UnitName("player"))) then
		ChatFrame1:AddMessage("A poison fades from your weapon!",1.0,0.0,0.0);
		UIErrorsFrame:AddMessage("A poison fades from your weapon!", 0.7, 1, 0.6, 1, 1.75);
	end
end